﻿SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION';
                                   
SET AUTOCOMMIT = 0;

START TRANSACTION;

ALTER TABLE `data` 
ADD COLUMN `key_id` INT(11) NULL DEFAULT NULL AFTER `data_table_id`,
ADD INDEX `fk_data_data1_idx` (`key_id` ASC);

ALTER TABLE `data` 
ADD CONSTRAINT `fk_data_data1`
    FOREIGN KEY (`key_id`)
    REFERENCES `data` (`id`)
    ON DELETE CASCADE
    ON UPDATE NO ACTION;

UPDATE `data` to_update
JOIN (SELECT data_values.id, data_values.value, data_values.column_id, data_values.row_id, key_ids.key_id as key_id FROM data data_values
	LEFT JOIN (SELECT id as key_id, row_id, is_key FROM `data` d
		JOIN (SELECT id as col_id, is_key FROM `column`) c
		ON d.column_id = c.col_id
		WHERE c.is_key = 1) key_ids
	ON data_values.row_id = key_ids.row_id AND data_values.id <> key_ids.key_id) data_modified
ON to_update.id = data_modified.id
SET to_update.key_id = data_modified.key_id;

COMMIT;
                                   
SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;